//+------------------------------------------------------------------+
//|                                                     3xMAs#2 .mq4 |
//|                                                    Adapted by cja|
//+------------------------------------------------------------------+
#property copyright "By cja"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_color4 DodgerBlue
#property indicator_color5 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 3
#property indicator_width4 4
#property indicator_width5 4

//---- input parameters
extern int EMAPeriod=3;           
extern int EMAShift=0;             
extern int SEMAPeriod=7;          
extern int SEMAShift=0;            
extern int SSEMAPeriod=25;         
extern int SSEMAShift=0;
extern bool SoundAlert_ON = false;
extern string SoundFile ="alert"; 
extern bool Show_Lines = true; 

extern int Arrow_UP = 233; 
extern int Arrow_DN = 234; 
extern int Arrow_Distance = 15;      
//---- indicator buffers
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];

double CrossUp[];
double CrossDown[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- line shifts when drawing
   SetIndexShift(0,EMAShift);
   SetIndexShift(1,SEMAShift);
   SetIndexShift(2,SSEMAShift);
//---- first positions skipped when drawing
   SetIndexDrawBegin(0,EMAShift+EMAPeriod);
   SetIndexDrawBegin(1,SEMAShift+SEMAPeriod);
   SetIndexDrawBegin(2,SSEMAShift+SSEMAPeriod);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, Arrow_UP);
   SetIndexBuffer(3, CrossUp);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, Arrow_DN);
   SetIndexBuffer(4, CrossDown);
   
//---- drawing settings
  if(Show_Lines==true){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   }
   else
   {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   }
//---- index labels
   SetIndexLabel(0,"EMA "+EMAPeriod+"");   
   SetIndexLabel(1,"EMA "+SEMAPeriod+"");   
   SetIndexLabel(2,"EMA "+SSEMAPeriod+"");   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| 3 X EMA                                          |
//+------------------------------------------------------------------+
int start()
  {
   static datetime dt = 0;
   int limit, i, counter;
     double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter,
     midEMAprevious, midEMAafter, midEMAnow;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   static datetime cDT = 0;
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      CrossUp[i] = 0; CrossDown[i] = 0;
      for (counter=i ;counter<=i+Arrow_Distance;counter++)// distance star above/below price 
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      //iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0); 
      fasterEMAnow = iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
      fasterEMAprevious = iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i+1);
      fasterEMAafter = iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i-1);
      
      midEMAnow = iMA(NULL,0,SEMAPeriod,0,MODE_EMA,PRICE_OPEN,i);
      midEMAprevious = iMA(NULL,0,SEMAPeriod,0,MODE_EMA,PRICE_OPEN,i+1);
      midEMAafter = iMA(NULL,0,SEMAPeriod,0,MODE_EMA,PRICE_OPEN,i-1);

      slowerEMAnow = iMA(NULL,0,SSEMAPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      slowerEMAprevious =  iMA(NULL,0,SSEMAPeriod,0,MODE_SMA,PRICE_CLOSE,i+1);
      slowerEMAafter =  iMA(NULL,0,SSEMAPeriod,0,MODE_SMA,PRICE_CLOSE,i-1);
      
      if ((midEMAnow > slowerEMAnow ) && (midEMAprevious < slowerEMAprevious)) {
         CrossUp[i] = Low[i] - Range*0.75; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
             
            if(SoundAlert_ON==true)PlaySound(SoundFile);
               dt = iTime(NULL,0,0);
            }
      }
      else  if ((midEMAnow < slowerEMAnow ) && (midEMAprevious > slowerEMAprevious)) {
         CrossDown[i] = High[i] + Range*0.75; // range # also affects star price difference
         if ((i < 2) && (dt != iTime(NULL,0,0)))
            {
            
            if(SoundAlert_ON==true)PlaySound(SoundFile);
               dt = iTime(NULL,0,0);
            }
      }
   //for(int i=0; i<limit; i++)
     {
      //---- ma_shift set to 0 because SetIndexShift called above
      ExtBuffer1[i]=iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i); 
      ExtBuffer2[i]=iMA(NULL,0,SEMAPeriod,0,MODE_EMA,PRICE_OPEN,i); 
      ExtBuffer3[i]=iMA(NULL,0,SSEMAPeriod,0,MODE_SMA,PRICE_CLOSE,i); 
     }}
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

